/*

args_4: Command line arguments parsing library
Yauheni A. Akhotnikau (C) 2002-2003
eao197@yahoo.com
-------------------------------------------------

Permission is granted to anyone to use this software for any purpose on any
computer system, and to redistribute it freely, subject to the following
restrictions:

1. This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

2. The origin of this software must not be misrepresented, either by
   explicit claim or by omission.

3. Altered versions must be plainly marked as such, and must not be
   misrepresented as being the original software.

-------------------------------------------------

*/
/*
	Args-4
*/

/*!
	\file
	\brief   /  iostream.
*/

#ifndef _ARGS_4__ARGS_IOSTREAM_HPP_
#define _ARGS_4__ARGS_IOSTREAM_HPP_

#include <iostream>

#include <args_4/h/args.hpp>

namespace args_4
{

/*
** iostream_error_stream_t
*/
/*!
	\brief     std::ostream.
*/
class	iostream_error_stream_t :
	public error_stream_t
{
	public :
		//!     std::cerr.
		iostream_error_stream_t();
		//!  .
		iostream_error_stream_t(
			//!  .
			/*!  %iostream_error_stream_t  
				    
				. */
			std::ostream * stream );
		virtual ~iostream_error_stream_t();

		/*!    m_stream. */
		virtual error_stream_t &
		out( const char * str );

	protected :
		/*!   . */
		std::ostream *	m_stream;
};

/*
** iostream_with_file_line_num_t
*/
/*!
	\brief        
	,    .

	  iostream_error_stream_t, 
	   words_from_file_t,  
	       
	.
*/
class	iostream_with_file_line_num_t :
	public iostream_error_stream_t
{
	public :
		//!    
		//!   std::cerr.
		iostream_with_file_line_num_t(
			const words_from_file_t & file );
		//!   .
		iostream_with_file_line_num_t(
			const words_from_file_t & file,
			//!  .
			/*!  %iostream_with_file_line_num_t  
				    
				. */
			std::ostream * stream );
		virtual ~iostream_with_file_line_num_t();

		/*!    
			 .  , 
			  '\n',  
			    
			     
			 . */
		virtual error_stream_t &
		out( const char * str );

	protected :
		/*!  ,   ,
			   . */
		const	words_from_file_t &	m_file;
		/*!  ,   
			 out     
			. */
		bool	m_is_new_line;
};

} /* namespace args_4 */

#endif

