/*

cls_2: Curl Like Syntax
Yauheni A. Akhotnikau (C) 2001-2003
eao197@yahoo.com
-------------------------------------------------

Permission is granted to anyone to use this software for any purpose on any
computer system, and to redistribute it freely, subject to the following
restrictions:

1. This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

2. The origin of this software must not be misrepresented, either by
   explicit claim or by omission.

3. Altered versions must be plainly marked as such, and must not be
   misrepresented as being the original software.

-------------------------------------------------

*/
/*!
	\file
	\brief	    
		     .
*/

#if !defined( _CLS_2__CHECK_DIGITS_HPP_ )
#define _CLS_2__CHECK_DIGITS_HPP_

namespace cls_2
{

bool
check_hex_digits( const char * p );

bool
check_oct_digits( const char * p );

bool
check_bin_digits( const char * p );

bool
check_dec_digits( const char * p );

bool
check_double_digits( const char * p );

/*!
	\brief     .

	 :
\verbatim
d* - decimal (d = [0-9])
-d* - negative decimal (d = [0-9], M = [0\])
Mxd* | MXd* - hex (d = [0-9a-fA-F], M = [0\])
Mod* | MOd* - octal (d = [0-7], M = [0\])
Mbd* | MBd* - binary (d = [01], M = [0\])
\endverbatim

	\return true,    .
*/
bool
parse_digits(
	//!   .
	const char * str,
	//!   .
	long & result,
	//!  ,  , 
	//!     
	//!  (0    ,
	//!     ).
	char base_mark = '0' );

/*!
	\brief     .

	 :
\verbatim
d* - decimal (d = [0-9])
Mxd* | MXd* - hex (d = [0-9a-fA-F], M = [0\])
Mod* | MOd* - octal (d = [0-7], M = [0\])
Mbd* | MBd* - binary (d = [01], M = [0\])
\endverbatim

	\return true,    .
*/
bool
parse_digits(
	//!   .
	const char * str,
	//!   .
	unsigned long & result,
	//!  ,  , 
	//!     
	//!  (0    ,
	//!     ).
	char base_mark = '0' );


/*
	Try parse double value.
	Representations:
		[-][d*][.d*][[eE][-][d*]]

	Returns true on success
*/
bool
parse_digits( const char * str, double & result );

}

#endif
