/*

cls_2: Curl Like Syntax
Yauheni A. Akhotnikau (C) 2001-2003
eao197@yahoo.com
-------------------------------------------------

Permission is granted to anyone to use this software for any purpose on any
computer system, and to redistribute it freely, subject to the following
restrictions:

1. This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

2. The origin of this software must not be misrepresented, either by
   explicit claim or by omission.

3. Altered versions must be plainly marked as such, and must not be
   misrepresented as being the original software.

-------------------------------------------------

*/
/*!
	\file
	\brief  .
*/

#if !defined( _CLS__LEX_HPP_ )
#define _CLS__LEX_HPP_

namespace cls_2 {

class	input_stream_t;
class	parser_context_t;

//
// Tokens
//
const int	c_tok_space = 1; // ' ', '\n', '\t', ...
const int	c_tok_nonspace = 2;
const int	c_tok_dquote = 3; // '\"'
const int	c_tok_open_block = 4; // '{'
const int	c_tok_close_block = 5; // '}'
const int	c_tok_eof = 6;
const int	c_tok_error = 7;
const int	c_tok_any = 8;

//
// lex_t
//

/*!
	\brief  .
	
	     
	.
*/
class	lex_t
{
	public :
		//!  .
		lex_t( input_stream_t & stream );
		~lex_t();

		//!   .
		/*
			\return c_ok,     .
		*/
		int
		get_tok(
			//!     .
			parser_context_t & context,
			//!   .
			int & tok,
			//!  ,    
			//!  c_tok_nonspace.
			char & ch );

	protected :
		//!  .
		input_stream_t &	m_stream;

		//!  ,  
		//!  .
		/*!
			 :
			\\n \\r \\t \\\\ \\{ \\} \\| \\"
			\\xDD \\XDD \\oDDD \\ODDD
			\\bDDDDDDDD \\BDDDDDDDD.

			\return c_ok,     .
		*/
		int
		parse_back_slash_seq(
			//!     .
			parser_context_t & context,
			//!   .
			int & tok,
			//!  ,    
			//!  c_tok_nonspace.
			char & ch );

		//!  ,  
		//!  .
		/*!
			    .

			\return c_ok,     .
		*/
		int
		parse_vert_bar(
			parser_context_t & context,
			int & tok,
			char & ch );

		//!   .
		/*!
			\return c_ok,     .
		*/
		int
		skip_single_line_comment(
			parser_context_t & context );

		//!   .
		/*!
			\return c_ok,     .
		*/
		int
		skip_start_stop_comment(
			parser_context_t & context );

		//!    .
		/*!
			\since v.2.6

			     
			,  ,  
			parse_digits.    
			parse_digits.   
			.

			\return c_ok,    .
		*/
		int
		parse_spec_char_representation(
			//!     .
			parser_context_t & context,
			//!   .
			int & tok,
			//!  ,    
			//!  c_tok_nonspace.
			char & ch,
			//! ,    .
			char base_mark,
			//!  ,   
			//!   .
			unsigned int char_count );
};

} /* namespace cls_2 */

#endif
