/*

cls_2: Curl Like Syntax
Yauheni A. Akhotnikau (C) 2001-2003
eao197@yahoo.com
-------------------------------------------------

Permission is granted to anyone to use this software for any purpose on any
computer system, and to redistribute it freely, subject to the following
restrictions:

1. This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

2. The origin of this software must not be misrepresented, either by
   explicit claim or by omission.

3. Altered versions must be plainly marked as such, and must not be
   misrepresented as being the original software.

-------------------------------------------------

*/

/*!
	\file
	\brief      
	 C++.
*/

#if !defined( _CLS_2__STD_CPP__UTILS_HPP_ )
#define _CLS_2__STD_CPP__UTILS_HPP_

#include <iostream>
#include <string>

#include <cls_2/h/cls.hpp>

namespace cls_2
{

namespace std_cpp
{

//! \name   parse_istream()  parse_file().
//! \{

//!          .
const unsigned int	es_uses_file_line = 0x1;

//!        .
const unsigned int	es_uses_tag_stack = 0x2;

//! \}

//
// parse_istream
//

//!    .
/*!
	   std::istream, 
	 .     std::ostream
	   .

	\return cls_2::c_ok,    .
*/
int
parse_istream(
	//!   .
	std::istream & in,
	//!   .    
	//!  ,    es_uses_file_line.
	const std::string & stream_name,
	//!  ,     .
	cls_2::tag_t ** tags,
	//!    tags.
	size_t tag_count,
	//!   .
	std::ostream * error_stream = 0,
	//!  .
	unsigned int options =
		es_uses_file_line | es_uses_tag_stack );

//
// parse_file
//

//!   .
/*!
	   , 
	 .     std::ostream
	   .   
	  std::ifstream.

	\return cls_2::c_ok,    .
*/
int
parse_file(
	//!    .
	const std::string & stream_name,
	//!  ,     .
	cls_2::tag_t ** tags,
	//!    tags.
	size_t tag_count,
	//!   .
	std::ostream * error_stream = 0,
	//!  .
	unsigned int options =
		es_uses_file_line | es_uses_tag_stack );

//
// parse_file
//

//!   .
/*!
	\since v.2.6.2

	   , 
	 .    
	error_desc.   
	  std::ifstream.

	  - ,     
	      
	      
	.

	\return cls_2::c_ok,    .
*/
int
parse_file(
	//!    .
	const std::string & stream_name,
	//!    .
	cls_2::tag_t & tag,
	//!   .
	std::string & error_stream,
	//!  .
	unsigned int options =
		es_uses_file_line | es_uses_tag_stack );

} /* namespace std_cpp */

} /* namespace cls_2 */

#endif
