/*

Copyright (c) 2002-2005, Yauheni Akhotnikau
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.

- The name of the author may not be used to endorse or promote products derived
from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.

*/

/*
	ObjESSty-1
*/

/*!
	\file
	\since v.1.0.9
	\brief         .
*/

#if !defined( _OESS_1__DB__CLN__SLICE_INDEX_BASE_HPP_ )
#define _OESS_1__DB__CLN__SLICE_INDEX_BASE_HPP_

#include <oess_1/db/h/declspec.hpp>

#include <oess_1/db/cln/h/db.hpp>
#include <oess_1/db/cln/h/slice_image_base.hpp>

namespace oess_1
{

namespace db
{

namespace cln
{

/*!
	\since v.1.0.0
	\brief        .
*/
class	OESS_1__DB__TYPE	slice_index_base_t
{
public:
	slice_index_base_t();
    virtual ~slice_index_base_t();

/*! \name ,   slice_image_base_t. */
/*! \{ */

	/*!      . */
	virtual void
	on_clear() = 0;

	/*!     .
		       
		    .
	*/
	virtual void
	on_insert(
		const oess_1::ent_id_t & id,
		const oess_1::stdsn::serializable_t & o ) = 0;

	/*!     . */
	virtual void
	on_erase(
		const oess_1::ent_id_t & id ) = 0;

	/*!      . */
	virtual void
	on_update(
		const oess_1::ent_id_t & id,
		const oess_1::stdsn::serializable_t & o ) = 0;

	/*!      . */
	virtual void
	on_attach() = 0;

	/*!      . */
	virtual void
	on_detach() = 0;

/*! \} */

private :
/*! \name   . */
/*! \{ */
	slice_index_base_t(
		const slice_index_base_t & o );
	slice_index_base_t &
	operator=(
		const slice_index_base_t & o );
/*! \} */
};

} /* namespace cln */

} /* namespace db */

} /* namespace oess_1 */

#endif
