/*

Copyright (c) 2002-2005, Yauheni Akhotnikau
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.

- The name of the author may not be used to endorse or promote products derived
from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.

*/

/*
	ObjESSty-1
*/

#include <auto_ptr_3/h/obj_ptr.hpp>

#include <oess_1/db/storage/h/stream_storage.hpp>

#include <oess_1/db/impl/db_content/h/db_content.hpp>

namespace oess_1 {

namespace db {

namespace impl {

namespace db_content {

//
// db_content_t
//

db_content_t::~db_content_t()
	{}

void
db_content_t::db_create(
	const std::string & name,
	const oess_1::db::storage::config_t & config )
	{
		auto_ptr_3::obj_ptr_t< oess_1::db::storage::stream_storage_t >
				storage( oess_1::db::storage::create_stream_storage(
						name, config ) );
	}

void
db_content_t::db_destroy(
	const std::string & name )
	{
		oess_1::db::storage::destroy_stream_storage( name );
	}

bool
db_content_t::db_is_exists(
	const std::string & name )
	{
		return oess_1::db::storage::is_stream_storage_exists( name );
	}

} /* namespace db_content */

} /* namespace impl */

} /* namespace db */

} /* namespace oess_1 */

