/*

Copyright (c) 2002-2005, Yauheni Akhotnikau
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.

- The name of the author may not be used to endorse or promote products derived
from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.

*/

/*
	ObjESSty-1
*/
#if !defined( _OESS_1__DB__IMPL__DB_CONTENT__ERRNO_HPP_ )
#define _OESS_1__DB__IMPL__DB_CONTENT__ERRNO_HPP_

#include <oess_1/defs/h/errno_range.hpp>

namespace oess_1 {

namespace db {

namespace impl {

namespace db_content {

namespace err {

const int c_range_min = oess_1::impl::c_errno__db__impl__db_content__min;
const int c_range_max = c_range_min + 1000;

//!   .
const int	c_db_not_open = c_range_min + 1;

//!   .
const int	c_db_open = c_range_min + 2;

//!       
//!  user_id.
const int	c_duplicate_system_stream_uid = c_range_min + 3;

//!      .
const int	c_system_stream_not_found = c_range_min + 4;

//!     .
const int	c_client_attached = c_range_min + 5;

//!     .
const int	c_client_not_attached = c_range_min + 6;

//!     .
const int	c_invalid_search_param = c_range_min + 7;

//!    .
const int	c_not_implemented = c_range_min + 8;

//!      ..  .
const int	c_transaction_in_progress = c_range_min + 9;

} /* namespace err */

} /* namespace db_content */

} /* namespace impl */

} /* namespace db */

} /* namespace oess_1 */

#endif
