/*

Copyright (c) 2002-2005, Yauheni Akhotnikau
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.

- The name of the author may not be used to endorse or promote products derived
from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.

*/

/*!
	\file
	\brief    ,  
	    .
*/

#if !defined( _OESS_1__DB__SITE__ABSTRACT_CONNECTOR_HPP_ )
#define _OESS_1__DB__SITE__ABSTRACT_CONNECTOR_HPP_

#include <oess_1/db/h/declspec.hpp>

#include <string>

#include <oess_1/defs/h/types.hpp>

namespace oess_1 {

namespace db {

namespace site {

namespace impl {

class	req_wrapper_t;
class	resp_wrapper_t;

} /* namespace impl */

//
// abstract_connector_t
//

/*!
	\brief    ,  
	    .
*/
class	OESS_1__DB__TYPE	abstract_connector_t
{
	public :
		abstract_connector_t();
		virtual ~abstract_connector_t();

		//!  ,  
		//! .
		virtual const std::string &
		query_client_id() const = 0;

		//!      .
		/*!   ,  
			    
			,   . */
		virtual void
		transmit(
			//!    .
			const impl::req_wrapper_t & req_wrapper,
			//!   .
			impl::resp_wrapper_t & resp_wrapper,
			//!   .
			oess_1::uint_t awaiting_resp_id ) = 0;

	private :
		abstract_connector_t(
			const abstract_connector_t & );
		abstract_connector_t &
		operator=(
			const abstract_connector_t & );
};

} /* namespace site */

} /* namespace db */

} /* namespace oess_1 */

#endif
