/*

Copyright (c) 2002-2005, Yauheni Akhotnikau
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.

- The name of the author may not be used to endorse or promote products derived
from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.

*/

/*
	ObjESSty-1
*/

/*!
	\file
	\brief  ,     
	.
*/

#if !defined( _OESS_1__DB__SITE__LOCALHOST_HPP_ )
#define _OESS_1__DB__SITE__LOCALHOST_HPP_

#include <oess_1/db/h/declspec.hpp>

#include <string>

#include <oess_1/defs/h/types.hpp>

#include <oess_1/db/storage/h/config.hpp>

#include <oess_1/db/site/h/abstract_connector.hpp>

namespace oess_1 {

namespace db {

namespace site {

namespace impl {

class	request_t;
class	response_t;

} /* namespace impl */

//
// localhost_t
//

/*!
	\brief  ,     
	.

	,    , 
	    .
*/
class	OESS_1__DB__TYPE	localhost_t
{
	public :
		virtual ~localhost_t();

		//!   .
		enum
		{
			//!     .
			no_overwrite = 1
		};

		//!    .
		/*! \since v.1.1.0

			     .

			     
			  .  
			     
			  db_describe(). */
		virtual void
		db_create(
			//!    (   ).
			const std::string & physic_name,
			//!   , 
			//!   .   
			//! no_overwrite,     .
			//!       
			//! .
			oess_1::uint_t creation_mode ) = 0;

		//!    .
		/*! \since v.1.4.0

			   , ..  
			    .

			     
			  .  
			     
			  db_describe(). */
		virtual void
		db_create(
			//!    (   ).
			const std::string & physic_name,
			//!   .
			const oess_1::db::storage::config_t & config,
			//!   , 
			//!   .   
			//! no_overwrite,     .
			//!       
			//! .
			oess_1::uint_t creation_mode ) = 0;

		//!     .
		virtual void
		db_describe(
			//!    (.. ,  
			//!    ).
			const std::string & logic_name,
			//!    (,   
			//!  ).
			const std::string & physic_name,
			//!      ( 
			//! ,    ).
			//! \deprecated    v.1.4. .
			oess_1::uint_t cache_size,
			//! true,       read-only.
			bool is_read_only,
			//! true,   
			//!    .
			bool is_auto_repair_enabled ) = 0;

		//!     .
		/*!
			\since v.1.4.0

			   , ..  
			    .
		*/
		virtual void
		db_describe(
			//!    (.. ,  
			//!    ).
			const std::string & logic_name,
			//!    (,   
			//!  ).
			const std::string & physic_name,
			//!    .
			const oess_1::db::storage::config_t & config,
			//! true,       read-only.
			bool is_read_only,
			//! true,   
			//!    .
			bool is_auto_repair_enabled ) = 0;

		//!       .
		/*!
			\deprecated    v.1.4.  
				    .
		*/
		virtual void
		db_flush_all() = 0;

		//! /  
		//!     ,
		//!   .
		/*!
			\deprecated    v.1.4.  
				    .

			   
			    ,   
			   .

			\return   
			 .
		*/
		virtual bool
		db_set_auto_flush(
			/*!   ,   
				. */
			const std::string & logic_name,
			/*!  true,    
				,  ,  
				  ""    . */
			bool is_on ) = 0;

		//!     .
		/*!    -
			 response,    
			 delete. */
		virtual impl::response_t *
		process(
			const impl::request_t & req ) = 0;

};

//
// create_std_localhost
//

/*!
	    localhost_t.
	     ,
	     
	delete.
*/
OESS_1__DB__FUNC(localhost_t *)
create_std_localhost();

//
// create_std_localhost_connector
//

/*!
	   
	abstract_connector_t,  
	   localhost_t.
	     ,
	     
	delete.
*/
OESS_1__DB__FUNC(abstract_connector_t *)
create_std_localhost_connector(
	localhost_t & );

} /* namespace site */

} /* namespace db */

} /* namespace oess_1 */

#endif
