/*

Copyright (c) 2002-2005, Yauheni Akhotnikau
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.

- The name of the author may not be used to endorse or promote products derived
from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.

*/

/*
	ObjESSty-1
*/

/*!
	\file oess_1/db/site/impl/h/request.hpp
	\brief       .
*/

#if !defined( _OESS_1__DB__SITE__IMPL__REQUEST_HPP_ )
#define _OESS_1__DB__SITE__IMPL__REQUEST_HPP_

#include <oess_1/stdsn/h/shptr.hpp>

namespace oess_1 {

namespace db {

namespace site {

namespace impl {

//
// request_t
//

/*!
	      
	 .
*/
class	request_t :
	public oess_1::stdsn::serializable_t
{
	OESS_SERIALIZER( request_t )
	public :
		request_t();
		request_t(
			//!  ,  .
			const std::string & client_id );
		virtual ~request_t();

		//!   .
		virtual oess_1::uint_t
		query_req_id() const = 0;

		//!  ,  .
		const std::string &
		query_client_id() const;

	private :
		//!  ,  .
		std::string	m_client_id;
};

//
// req_wrapper_t
//

/*!
	   request_t.  
	  (   
	     
	).
*/
class	req_wrapper_t :
	public oess_1::stdsn::shptr_t
{
	OESS_SERIALIZER( req_wrapper_t )
	OESS_1_SHPTR_IFACE( req_wrapper_t,
		oess_1::db::site::impl::request_t,
		oess_1::stdsn::shptr_t )
};

} /* namespace impl */

} /* namespace site */

} /* namespace db */

} /* namespace oess_1 */

#endif
