/*

Copyright (c) 2002-2005, Yauheni Akhotnikau
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.

- The name of the author may not be used to endorse or promote products derived
from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.

*/

/*
	ObjESSty-1
*/

/*!
	\file oess_1/db/site/impl/h/response.hpp
	\brief        .
*/

#if !defined( _OESS_1__DB__SITE__IMPL__RESPONSE_HPP_ )
#define _OESS_1__DB__SITE__IMPL__RESPONSE_HPP_

#include <oess_1/defs/h/err_code.hpp>

#include <oess_1/stdsn/h/shptr.hpp>

namespace oess_1 {

namespace db {

namespace site {

namespace impl {

//
// result_t
//

/*!
	        .
*/
class	result_t :
	public oess_1::stdsn::serializable_t
{
	OESS_SERIALIZER( result_t )
	public :
		result_t();
		result_t(
			const oess_1::err_code_t & err );
		result_t(
			const result_t & o );
		virtual ~result_t();

		result_t &
		operator=( const result_t & o );

		oess_1::err_code_t
		query_err_code() const;

	private :
		//!   .
		oess_1::int_t	m_code;
		//!  ,      err_code_t.
		std::string	m_file;
		//!   ,     
		//! err_code_t.
		int	m_line;
		//!   .  .
		std::string	m_desc;
};

//
// response_t
//

/*!
	      .
*/
class	response_t :
	public oess_1::stdsn::serializable_t
{
	OESS_SERIALIZER( response_t )
	public :
		response_t();
		response_t(
			//!   .
			const result_t & result );
		virtual ~response_t();

		//!   .
		virtual oess_1::uint_t
		query_resp_id() const = 0;

		//!   .
		const result_t &
		query_result() const;

	private :
		//!   .
		result_t	m_result;
};

//
// resp_wrapper_t
//

/*!
	   response_t.  
	  (   
	     
	).
*/
class	resp_wrapper_t :
	public oess_1::stdsn::shptr_t
{
	OESS_SERIALIZER( resp_wrapper_t )
	OESS_1_SHPTR_IFACE( resp_wrapper_t,
		oess_1::db::site::impl::response_t,
		oess_1::stdsn::shptr_t )
};

} /* namespace impl */

} /* namespace site */

} /* namespace db */

} /* namespace oess_1 */

#endif
