/*

Copyright (c) 2002-2005, Yauheni Akhotnikau
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.

- The name of the author may not be used to endorse or promote products derived
from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.

*/

/*!
	\file
	\since v.1.4.0
	\brief      .
*/

#if !defined( _OESS_1__DB__STORAGE__LOADED_PAGE_HPP_ )
#define _OESS_1__DB__STORAGE__LOADED_PAGE_HPP_

#include <cpp_util_2/h/nocopy.hpp>

#include <smart_ref_3/h/smart_ref.hpp>

#include <oess_1/db/h/declspec.hpp>

#include <oess_1/defs/h/types.hpp>

namespace oess_1 {

namespace db {

namespace storage {

//
// loaded_page_t
//

/*!
	\since v.1.4.0
	\brief    ,   .
*/
class	OESS_1__DB__TYPE	loaded_page_t
	:	private cpp_util_2::nocopy_t
	{
	public :
		//!  .
		loaded_page_t(
			//!     .
			oess_1::uint_t ordinal,
			//!    .
			oess_1::uint_t page_size );
		~loaded_page_t();

		//!    .
		oess_1::uint_t
		ordinal() const
			{
				return m_ordinal;
			}

		//!     .
		oess_1::uint_t
		page_size() const
			{
				return m_page_size;
			}
		
		//!      .
		oess_1::char_t *
		current()
			{
				return m_buffer;
			}

		//!       .
		const oess_1::char_t *
		current() const
			{
				return m_buffer;
			}

		/*!
			\return true,     .
				..      change_previous_by_current().
		*/
		bool
		has_previous() const
			{
				return m_has_previous;
			}

		//!       .
		/*!
			\attention     , 
				    
				change_previous_by_current().
		*/
		const oess_1::char_t *
		previous() const
			{
				return m_previous;
			}

		//!      .
		void
		change_previous_by_current();

	private :
		//!     .
		oess_1::uint_t	m_ordinal;
		//!    .
		oess_1::uint_t m_page_size;

		//!     .
		/*!
			        
			     .  
			     ,  
			.
		*/
		oess_1::char_t *	m_buffer;

		//!       .
		oess_1::char_t *	m_previous;

		//!  ,     .
		bool	m_has_previous;
	};

//
// ref_loaded_page_t
//

SMART_REF_3_DECL_REF( loaded_page_t, class OESS_1__DB__TYPE )

} /* namespace storage */

} /* namespace db */

} /* namespace oess */

#endif


