/*

Copyright (c) 2002-2005, Yauheni Akhotnikau
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.

- The name of the author may not be used to endorse or promote products derived
from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.

*/

/*!
	\since v.1.4.0
	\brief    %snapshot_collection_t.
*/
#if !defined( _OESS_1__DB__STORAGE__TRX__STD_SNAPSHOT_COLLECTION_HPP_ )
#define _OESS_1__DB__STORAGE__TRX__STD_SNAPSHOT_COLLECTION_HPP_

#include <oess_1/db/storage/trx/h/types.hpp>

namespace oess_1 {

namespace db {

namespace storage {

namespace trx {

//
// std_snapshot_collection_t
//

/*!
	\since v.1.4.0
	\brief    %snapshot_collection_t.
*/
class	std_snapshot_collection_t
	:	public snapshot_collection_t
	{
	public :
		//!  .
		std_snapshot_collection_t(
			//!        .
			const std::string & physic_name );
		virtual ~std_snapshot_collection_t();

	//! \name   .
	/*! \{ */
		virtual unsigned int
		size() const;

		virtual trace_file_number_set_t
		non_actual() const;

		virtual trace_file_number_t
		actual() const;

		virtual bool
		has_actual() const;

		virtual void
		include(
			const std::string & file_name,
			trace_file_number_t last_used_trace );

		virtual void
		get_actual(
			const std::string & file_name ) const;

		virtual void
		destroy();
	/*! \} */

	private :
		//!        .
		std::string	m_physic_name;

		//!    snapshot-.
		trace_file_number_set_t	m_all_snapshot_numbers;
	};

} /* namespace trx */

} /* namespace storage */

} /* namespace db */

} /* namespace oess */

#endif

