/*

Copyright (c) 2002-2005, Yauheni Akhotnikau
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.

- The name of the author may not be used to endorse or promote products derived
from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.

*/

/*!
	\file oess_1/defs/h/errno_range.hpp
	\brief     
	 ObjESSty.

	       
	  1000  . 
	      , 
	   .
*/

#if !defined( _OESS_1__DEFS__ERRNO_RANGE_HPP_ )
#define _OESS_1__DEFS__ERRNO_RANGE_HPP_

namespace oess_1
{

namespace impl
{

//!     scheme.
const int	c_errno__scheme = 1000;

//!     io.
const int	c_errno__io__min = 2000;

//!     storage   db.
const int	c_errno__db__storage__min = 3000;

//!     db_struct   db.
const int	c_errno__db__impl__db_struct__min = 4000;

//!     db_manipulator   db.
const int	c_errno__db__impl__db_manipulator__min = 5000;

//!     db_content   db.
const int	c_errno__db__impl__db_content__min = 6000;

//!     db_site   db.
const int	c_errno__db__site__min = 7000;

//!     cln   db.
const int	c_errno__db__cln__min = 8000;

//!     file.
const int	c_errno__file__min = 9000;

//!     stdsn.
const int	c_errno__stdsn__min = 10000;

//!     tlv.
const int	c_errno__tlv__min = 11000;

} /* namespace impl */

} /* namespace oess_1 */

#endif

