/*

Copyright (c) 2002-2005, Yauheni Akhotnikau
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.

- The name of the author may not be used to endorse or promote products derived
from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.

*/

#if !defined( _OESS_1__FILE__ERRNO_HPP_ )
#define _OESS_1__FILE__ERRNO_HPP_

#include <oess_1/defs/h/errno_range.hpp>

namespace oess_1 {

namespace file {

namespace err {

const int	c_range_min = oess_1::impl::c_errno__file__min;
const int	c_range_max = c_range_min + 1000;

/*!   . */
const int	c_cannot_open_file = c_range_min + 2;

/*!   . */
const int	c_cannot_lock_file = c_range_min + 3;

/*!   . */
const int	c_cannot_unlock_file = c_range_min + 4;

/*!   .  */
const int	c_cannot_create_file = c_range_min + 5;

/*!    . */
const int	c_cannot_truncate_file = c_range_min + 6;

/*!   . */
const int	c_file_open = c_range_min + 7;

/*!  . */
const int	c_unexpected = c_range_min + 8;

/*!  . */
const int	c_read_fail = c_range_min + 9;

/*!  . */
const int	c_write_fail = c_range_min + 10;

/*!   . */
const int	c_file_not_open = c_range_min + 11;

/*!     . */
const int	c_read_only_mode = c_range_min + 12;

/*!   . */
const int	c_cannot_remove_file = c_range_min + 13;

/*!    .

	,   ,    
	  . */
const int	c_target_already_exists = c_range_min + 14;

/*!   . */
const int	c_rename_fail = c_range_min + 15;

} /* namespace err */

} /* namespace io */

} /* namespace oess_1 */

#endif
