/*

Copyright (c) 2002-2005, Yauheni Akhotnikau
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.

- The name of the author may not be used to endorse or promote products derived
from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.

*/

#if !defined( _OESS_1__FILE__IMPL__FILETOOL_HPP_ )
#define _OESS_1__FILE__IMPL__FILETOOL_HPP_

#include <oess_1/defs/h/types.hpp>

namespace oess_1 {

namespace file {

namespace impl {

/*!     . */
int
open_and_lock( const oess_1::char_t * file_name,
	bool is_read_only );

/*!     . */
void
unlock_and_close( int file );

/*!   (  ) 
	 . */
int
create_and_lock(
	const oess_1::char_t * file_name );

/*!      . */
void
truncate_file( int file, oess_1::uint_t size );

/*!  . */
void
remove_file( const oess_1::char_t * file_name );

/*!
	\since v.1.1.0
	\brief      .

	\return true,   . false,   
		,      
		   (, ). */
bool
is_file_exists( const oess_1::char_t * file_name );

} /* namespace impl */

} /* namespace file */

} /* namespace oess_1 */

#endif
