/*

Copyright (c) 2002-2005, Yauheni Akhotnikau
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.

- The name of the author may not be used to endorse or promote products derived
from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.

*/

#if !defined( _OESS_1__SCHEME__ERRNO_HPP_ )
#define _OESS_1__SCHEME__ERRNO_HPP_

#include <oess_1/defs/h/errno_range.hpp>

namespace oess_1 {

namespace scheme {

namespace err {

const int	c_range_min = oess_1::impl::c_errno__scheme;
const int	c_range_max = c_range_min + 1000;

//!      .
const int	c_base_already_defined = c_range_min + 1;

//!     .
const int	c_invalid_index_of_base = c_range_min + 2;

//!      .
const int	c_attr_already_defined = c_range_min + 3;

//!    .
const int	c_invalid_index_of_attr = c_range_min + 4;

//!    .
const int	c_zero_pointer = c_range_min + 5;

//!   .
const int	c_type_not_found = c_range_min + 6;

//!   .
const int	c_attr_editor_exists = c_range_min + 7;

//!    .
const int	c_attr_editor_not_exists = c_range_min + 8;

//!      .
const int	c_invalid_index_of_type = c_range_min + 9;

//!   .
const int	c_type_editor_exists = c_range_min + 10;

//!    .
const int	c_type_editor_not_exists = c_range_min + 11;

//!      .
const int	c_type_already_defined = c_range_min + 12;

//!    DDL .
const int	c_ddl_syntax_error = c_range_min + 13;

//!     .
const int	c_invalid_attr_type_kind = c_range_min + 15;

//!    .
const int	c_invalid_attr_cont_kind = c_range_min + 16;

//!   .
const int	c_type_not_defined = c_range_min + 17;

//!      .
const int	c_abstract_type_for_attr = c_range_min + 18;

//!    .
const int	c_cycle = c_range_min + 19;

//!        .
const int	c_builtin_type_as_base = c_range_min + 20;

//!      .
/*!
	\since v.1.2.0

	    
	    ,   
	      {present_if}.
	,  ddl-   :
\verbatim
{type A
	{attr	a {of std::string}
		{default {c++ \"a\"}
			{present_if}}
	}
}
\endverbatim
*/
const int	c_no_present_if_predicate_code = c_range_min + 21;

//!     .
/*!
	\since v.1.2.0

	     ,
	      .
*/
const int	c_serialization_code_generation_fail = c_range_min + 22;

//!    -  .
/*!
	\since v.1.2.0

	    
	    ,   
	      -
	 .
	,  ddl-   :
\verbatim
{type A
	{attr	a {of std::string}
		{default}
	}
}
\endverbatim
*/
const int	c_no_default_expression = c_range_min + 23;

//!     .
/*!
	\since v.1.2.0

	,      
	    ,   
	 .
*/
const int c_extension_level_mismatch = c_range_min + 24;

//!    .
/*!
	\since v.1.2.0

	     ,
	   . , 
	  .
*/
const int c_not_extensible_type = c_range_min + 25;

//!  subclassing_by_extension  .
/*!
	\since v.1.2.0

	    subclassing_by_extension
	    .
*/
const int c_already_derived_as_extension = c_range_min + 26;

//!   ,  
//!    .
/*!
	\since v.1.2.0
*/
const int c_mi_disabled_when_derived_as_extension = c_range_min + 27;

//!    present_if    .
/*!
	\since v.1.4.0

	  ObjESSty.

	     
	present_if,    .  
	    .   ,
	 -    present_if  
	 .
*/
const int c_try_get_present_if_for_nonoptional_attr = c_range_min + 28;

//!       .
/*!
	\since v.1.4.0

	  ObjESSty.

	    -  .
*/
const int c_default_attr_value_already_defined = c_range_min + 29;

//!      -.
/*!
	\since v.1.4.0

	  ObjESSty.

	    -  .
*/
const int c_default_attr_value_missed = c_range_min + 30;

} /* namespace err */

} /* namespace scheme */

} /* namespace oess_1 */

#endif
