/*

Copyright (c) 2002-2005, Yauheni Akhotnikau
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.

- The name of the author may not be used to endorse or promote products derived
from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.

*/

/*!
	\since v.1.4.0-b2
	\file
	\brief    /
		   .
*/

#if !defined( OESS_1__STDSN__CUSTOM_INOUT_TEMPL_HPP )
#define OESS_1__STDSN__CUSTOM_INOUT_TEMPL_HPP

#include <oess_1/stdsn/h/inout_templ.hpp>

/*!
	\since v.1.4.0-b2
	\brief    /
		   .

	 ,    /
	       
	 :
	-      / oess_1::io::ostream_t 
	oess_1::io::istream_t;
	-      oess_1::stdsn::oobj_t 
	oess_1::stdsn::iobj_t.

	      , .. ObjESSty
	 ,       .  
	     . 
	  -    . , :
	\code
	namespace some_project
	{
	//    .
	class my_class_t { ... };

	//     .
	oess_1::io::istream_t &
	operator>>( oess_1::io::istream_t & in, my_class_t & o ) { ... }

	oess_1::io::ostream_t &
	operator<<( oess_1::io::ostream_t & out, my_class_t & o ) { ... }
	}
	
	//       .
	OESS_1_STDSN_SPECIALIZE_CUSTOM_TYPE( some_project::my_class_t )
	\endcode
*/
#define OESS_1_STDSN_SPECIALIZE_CUSTOM_TYPE(type) \
namespace oess_1 { \
namespace stdsn { \
OESS_1_STDSN_SPECIALIZE_TYPE_IMPL(type) \
} \
}

#endif

