/*

Copyright (c) 2002-2005, Yauheni Akhotnikau
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.

- The name of the author may not be used to endorse or promote products derived
from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.

*/

/*!
	\file
	\brief      .
*/

#if !defined( _OESS_1__STDSN__ENT_HPP_ )
#define _OESS_1__STDSN__ENT_HPP_

#include <cpp_util_2/h/nocopy.hpp>

#include <oess_1/stdsn/h/declspec.hpp>

#include <oess_1/io/h/stream.hpp>

namespace oess_1 {

namespace stdsn {

class	iextension_t;
class	oextension_t;

class	unknown_extension_t;

//
// ient_t
//

/*!
	\brief      
	  .
*/
class	OESS_1__STDSN__TYPE	ient_t
:	private cpp_util_2::nocopy_t
{
	public :
		virtual ~ient_t();

		/*!
			    .

			\return true,     . false,
				    - 
				    
				     .
		*/
		virtual bool
		obj_start(
			const void * object,
			const std::string * type_name,
			const std::string & scheme ) = 0;

		/*!
			    
			    .
		*/
		virtual void
		obj_finish(
			const void * object,
			const std::string * type_name ) = 0;

		/*!
			     .
			     
			obj_finish  obj_complete       
			   ,
			    .
		*/
		virtual void
		obj_complete(
			const void * object,
			const std::string * type_name ) = 0;

		//!      .
		/*!
			      
			     .
			     
			    (  ,
			   ..).
		*/
		virtual void
		unpack_type_name(
			//!    .
			std::string & type_name ) = 0;

		//!     .
		virtual oess_1::io::istream_t &
		query_stream() = 0;

		/*!
			\since v.1.2.0
			\brief    
				 .
			\return \a true,    
				     . \a false  
				.
		*/
		virtual bool
		check_optional_attr_existence(
			//!   .
			const std::string & attr_name ) = 0;

		/*!
			\since v.1.2.0
			\brief  ,   
				.

			     
			 .

			\return   ,  
				   delete.
		*/
		virtual iextension_t *
		extension_start() = 0;

		/*!
			\since v.1.2.0
			\brief    
				.
		*/
		virtual void
		extension_finish(
			//! ,    
			//!  extension_start().
			iextension_t & extension ) = 0;
};

//
// iextension_t
//

/*!
	\since v.1.2.0
	\brief      
		   .
*/
class	OESS_1__STDSN__TYPE	iextension_t
:	public ient_t
{
	public :
		virtual ~iextension_t();

	//! \name  .
	//! \{
		virtual bool
		obj_start(
			const void * object,
			const std::string * type_name,
			const std::string & scheme ) = 0;

		virtual void
		obj_finish(
			const void * object,
			const std::string * type_name ) = 0;

		virtual void
		obj_complete(
			const void * object,
			const std::string * type_name ) = 0;

		virtual void
		unpack_type_name(
			std::string & type_name ) = 0;

		virtual oess_1::io::istream_t &
		query_stream() = 0;

		virtual bool
		check_optional_attr_existence(
			const std::string & attr_name ) = 0;

		virtual iextension_t *
		extension_start() = 0;

		virtual void
		extension_finish(
			iextension_t & extension ) = 0;
	//! \}

		/*!
			\brief     .
			\return \a true,       
				   .
		*/
		virtual bool
		is_present() const = 0;

		/*!
			\brief      
				    .
		*/
		virtual void
		unpack_opaque( unknown_extension_t & ext ) = 0;
};

//
// oent_t
//

/*!
	\brief      
	  .
*/
class	OESS_1__STDSN__TYPE	oent_t
:	private cpp_util_2::nocopy_t
{
	public :
		virtual ~oent_t();

		/*!
			    .

			\return true,     . false,
				    - 
				    
				     .
		*/
		virtual bool
		obj_start(
			//!    .
			const void * object,
			//!       
			//!  obj_finish.
			const std::string * type_name,
			const std::string & scheme ) = 0;

		//!      .
		virtual void
		obj_finish(
			//!    .    ,
			//!      obj_start.
			const void * object,
			//!    ,   
			//!  obj_start.
			const std::string * type_name ) = 0;

		/*!
			     .
			     
			obj_finish  obj_complete       
			   ,
			    .
		*/
		virtual void
		obj_complete(
			const void * object,
			const std::string * type_name ) = 0;

		//!      .
		/*!
			      
			     .
			     
			    (  ,
			   ..).

			\par v.1.1.0
			  type_scheme.
		*/
		virtual void
		pack_type_name(
			//!    .
			const std::string & type_name,
			//!    .
			const std::string & type_scheme ) = 0;

		//!     .
		virtual oess_1::io::ostream_t &
		query_stream() = 0;

		/*!
			\since v.1.2.0
			\brief    
				 .
			\return   \a existence.
		*/
		virtual bool
		set_optional_attr_existence(
			//!   .
			const std::string & attr_name,
			//!    .
			//! \a true,  , \a false   .
			bool existence ) = 0;

		/*!
			\since v.1.2.0
			\brief  ,   
				.

			     
			.

			\return   ,  
				   delete.
		*/
		virtual oextension_t *
		extension_start() = 0;

		/*!
			\since v.1.2.0
			\brief    
				.
		*/
		virtual void
		extension_finish(
			//! ,    
			//!  extension_start().
			oextension_t & extension ) = 0;
};

//
// oextension_t
//

/*!
	\since v.1.2.0
	\brief       
	  .
*/
class	OESS_1__STDSN__TYPE	oextension_t
:	public oent_t
{
	public :
		virtual ~oextension_t();

	//! \name   .
	//! \{
		virtual bool
		obj_start(
			const void * object,
			const std::string * type_name,
			const std::string & scheme ) = 0;

		virtual void
		obj_finish(
			const void * object,
			const std::string * type_name ) = 0;

		virtual void
		obj_complete(
			const void * object,
			const std::string * type_name ) = 0;

		virtual void
		pack_type_name(
			const std::string & type_name,
			const std::string & type_scheme ) = 0;

		virtual oess_1::io::ostream_t &
		query_stream() = 0;

		virtual bool
		set_optional_attr_existence(
			const std::string & attr_name,
			bool existence ) = 0;

		virtual oextension_t *
		extension_start() = 0;

		virtual void
		extension_finish(
			oextension_t & extension ) = 0;
	//! \}

		/*!
			\brief     .

			,  ,   , 
			    . 
			      ,
			       
			 .     
			 .
		*/
		virtual void
		pack( oess_1::io::ostream_t & to ) const = 0;

		/*!
			\brief     .

			,  ,   , 
			    .  
			   ,     
			 ,     
			      
			.      
			.
		*/
		virtual void
		pack_opaque( const unknown_extension_t & ext ) = 0;
};

//
// isubclass_extension_t
//

/*!
	\since v.1.2.0
	\brief    
		   subclassing_by_extension.
*/
class	OESS_1__STDSN__TYPE	isubclass_extension_t
	{
		public :
			virtual ~isubclass_extension_t();

			//!     
			//!   .
			virtual void
			operator()( ient_t & ) = 0;
	};

//
// osubclass_extension_t
//

/*!
	\since v.1.2.0
	\brief    
		   subclassing_by_extension.
*/
class	OESS_1__STDSN__TYPE	osubclass_extension_t
	{
		public :
			virtual ~osubclass_extension_t();

			//!     
			//!   .
			virtual void
			operator()( oent_t & ) = 0;
	};

//
// isubclass_extension_template_t
//

/*!
	\since v.1.2.0
	\brief   %isubclass_extension_t  
		.
*/
template< class T >
class	isubclass_extension_template_t
:	public isubclass_extension_t
	{
		public :
			//!     .
			typedef T object_t;
			//!   ,   .
			typedef void (*unpack_self_t)(
				ient_t &, T &, isubclass_extension_t * );

			//!  .
			isubclass_extension_template_t(
				//!  .
				object_t & o,
				//! ,    .
				unpack_self_t unpack_self,
				//!    .
				//!   ,    .
				isubclass_extension_t * subclass )
				:	m_object( o )
				,	m_unpack_self( unpack_self )
				,	m_subclass( subclass )
				{}

			virtual void
			operator()( ient_t & from )
				{
					(*m_unpack_self)( from, m_object, m_subclass );
				}

		private :
			//!  .
			object_t &	m_object;
			//! ,    .
			unpack_self_t	m_unpack_self;
			//!    .
			/*!
				 0 ,    .
			*/
			isubclass_extension_t *	m_subclass;
	};

//
// osubclass_extension_template_t
//

/*!
	\since v.1.2.0
	\brief   %osubclass_extension_t  
		.
*/
template< class T >
class	osubclass_extension_template_t
:	public osubclass_extension_t
	{
		public :
			//!     .
			typedef T object_t;
			//!   ,   .
			typedef void (*pack_self_t)(
				oent_t &, const T &, osubclass_extension_t * );

			//!  .
			osubclass_extension_template_t(
				//!  .
				const object_t & o,
				//! ,    .
				pack_self_t pack_self,
				//!    .
				//!   ,    .
				osubclass_extension_t * subclass )
				:	m_object( o )
				,	m_pack_self( pack_self )
				,	m_subclass( subclass )
				{}

			virtual void
			operator()( oent_t & from )
				{
					(*m_pack_self)( from, m_object, m_subclass );
				}

		private :
			//!  .
			const object_t &	m_object;
			//! ,    .
			pack_self_t	m_pack_self;
			//!    .
			/*!
				 0 ,    .
			*/
			osubclass_extension_t *	m_subclass;
	};


} /* namespace stdsn */

} /* namespace oess_1 */

#endif
