/*

Copyright (c) 2002-2005, Yauheni Akhotnikau
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.

- The name of the author may not be used to endorse or promote products derived
from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.

*/

/*!
	\file oess_1/stdsn/h/errno.hpp
	\brief    stdsn.
*/

#if !defined( _OESS_1__STDSN__ERRNO_HPP_ )
#define _OESS_1__STDSN__ERRNO_HPP_

#include <oess_1/defs/h/errno_range.hpp>

namespace oess_1 {

namespace stdsn {

namespace err {

const int	c_range_min = oess_1::impl::c_errno__stdsn__min;
const int	c_range_max = c_range_min + 1000;

//!     .
const int	c_factory_not_found = c_range_min + 1;

//!       .
const int	c_cast_fail = c_range_min + 2;

/*!
	\since v.1.2.0
	\brief     subclassing_by_extension.

	   :
	-  ,   DDL  {attr {of {extension_of}}}, 
	     ,  
	    . ..  
	    ,    
	   subclassing_by_extension;
	-    DDL  {attr {of {extension_of}}}  
	.
*/
const int	c_invalid_subclass_extension_chain = c_range_min + 3;

/*!
	\since v.1.2.0
	\brief      
		subclassing_by_extension.

	   ,   DDL 
	{attr {of {extension_of}}}, 
	     ,  
	    . ..  
	    ,    
	   subclassing_by_extension;
*/
const int	c_not_in_subclass_extension_chain = c_range_min + 3;

/*!
	\since v.1.2.0
	\brief      
		  subclassing_by_extension.

	     
	   ,   
	    ,   
	  .  
	(    {attr {of {extension_of}}})  -
	      (,
	      ).

	    ,   
	    
	 .
*/
const int	c_nearest_base_not_found = c_range_min + 4;

/*!
	\since v.1.4.0
	\brief -    
		   reassign.

	,  oess_1::stdsn::refcountable_policy_t 
	  oess_1::stdsn::refcountable_policy_t::m_ref_count 
	  reassign.    ,   
	reassign  .
*/
const int	c_invalid_policy_state_for_reassignment = c_range_min + 5;

/*!
	\since v.1.4.0
	\brief     .

	       
	  ()    .
	  --     .
*/
const int	c_cast_failed = c_range_min + 6;

} /* namespace err */

} /* namespace stdsn */

} /* namespace oess_1 */

#endif
